import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import cx from "classnames";
import styles from "./Button.less";
export var Button = /*#__PURE__*/React.forwardRef(function Button(props, ref) {
  return /*#__PURE__*/React.createElement("button", _extends({}, props, {
    ref: ref,
    className: cx(styles.Button, styles[props.kind], styles[props.type], styles[props.size], props.className)
  }), props.text, React.Children.map(React.Children.toArray(props.children), function (child, i) {
    // If the first child is an element
    // assume it's an icon
    if (child.props && i === 0) {
      return /*#__PURE__*/React.cloneElement(child, {
        className: React.Children.toArray(props.children).length > 1 ? cx(styles.icon, child.props.className) : child.props.className
      });
    } else {
      // probably just a text node
      return child;
    }
  }));
});