import React from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faExclamationTriangle } from "@fortawesome/free-solid-svg-icons";
import { Card, CardFooter, CardContent } from "../Card";
import { Button } from "../Button";
import { ButtonGroup } from "../ButtonGroup";
import styles from "./ConfirmDialog.less";
export var ConfirmDialog = function ConfirmDialog(props) {
  return props.isOpen && /*#__PURE__*/React.createElement("section", {
    className: styles.confirmWrapper
  }, /*#__PURE__*/React.createElement(Card, {
    className: cx(styles.Confirm, styles[props.kind], props.className)
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("h3", null, props.prompt)), /*#__PURE__*/React.createElement(CardFooter, null, props.children ?
  /*#__PURE__*/
  // custom buttonGroup renders
  React.createElement(ButtonGroup, {
    className: "".concat(styles.buttons, " ").concat(props.single ? styles["short"] : "")
  }, props.children) : /*#__PURE__*/React.createElement(ButtonGroup, {
    className: "".concat(styles.buttons, " ").concat(props.single ? styles["short"] : "")
  }, /*#__PURE__*/React.createElement(Button, {
    id: "confirmTrue",
    type: props.type,
    onClick: function onClick() {
      props.callback(true);
    }
  }, props.kind === "warn" && /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faExclamationTriangle
  }), props.confirmText || "Yes"), /*#__PURE__*/React.createElement(Button, {
    id: "confirmFalse",
    onClick: function onClick() {
      props.callback(false);
    },
    className: props.single ? styles.hide : "",
    text: "No"
  }))))) || null;
};