import React from "react";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faBook, faShare } from "@fortawesome/free-solid-svg-icons";
import { Url } from "../Url";
import styles from "./Docs.less";
import cx from "classnames";
export function Docs(props) {
  return /*#__PURE__*/React.createElement(Url, {
    target: "_blank",
    title: "Open documentation for ".concat(props.subject),
    className: styles.DocsLink,
    href: props.url ? props.url : "https://zesty.org/?q=".concat(props.subject)
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faBook,
    className: cx(styles.icon, styles.book)
  }), /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faShare,
    className: cx(styles.icon, styles.share)
  }), "Docs");
}