import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState, useRef } from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faPaintBrush } from "@fortawesome/free-solid-svg-icons";
import { Button } from "../Button";
import { Input } from "../Input";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeColor.less";
export var FieldTypeColor = /*#__PURE__*/React.memo(function FieldTypeColor(props) {
  // console.log("Render:FieldTypeColor");
  var _useState = useState(props.value || "#ffffff"),
      _useState2 = _slicedToArray(_useState, 2),
      color = _useState2[0],
      setColor = _useState2[1];

  var ref = useRef();
  return /*#__PURE__*/React.createElement("label", {
    className: cx(styles.FieldTypeColor, props.className)
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.FieldTypeColorInput
  }, /*#__PURE__*/React.createElement(Input, {
    ref: ref,
    className: styles.ColorInput,
    type: "color",
    required: props.required,
    value: color,
    onChange: function onChange(evt) {
      if (props.onChange) {
        props.onChange(evt.target.value, props.name, props.datatype);
      }

      setColor(evt.target.value);
    }
  }), /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      ref.current.click();
    },
    className: styles.Icon
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faPaintBrush
  }))), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});