import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from "react";
import { Input } from "../Input";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import { Select, Option } from "../Select";
import { currencies } from "./currencies";
import styles from "./FieldTypeCurrency.less";
export var FieldTypeCurrency = /*#__PURE__*/React.memo(function FieldTypeCurrency(props) {
  // console.log("FieldTypeCurrency:render");
  var _useState = useState(props.value || "0.00"),
      _useState2 = _slicedToArray(_useState, 2),
      monetaryValue = _useState2[0],
      setMonetaryValue = _useState2[1];

  var _useState3 = useState(props.code && currencies[props.code] || currencies["USD"]),
      _useState4 = _slicedToArray(_useState3, 2),
      currency = _useState4[0],
      setCurrency = _useState4[1];

  return /*#__PURE__*/React.createElement("label", {
    className: styles.FieldTypeCurrency
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.FieldTypeCurrencyLabel
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: "View this value in different currencies based upon your locale \"".concat(window.navigator.language, "\"")
  }), /*#__PURE__*/React.createElement("span", null, Number(monetaryValue).toLocaleString(window.navigator.language, {
    style: "currency",
    currency: currency.code
  }))), /*#__PURE__*/React.createElement("p", {
    className: styles.Description
  }, props.description), /*#__PURE__*/React.createElement("div", {
    className: styles.CurrencyFields
  }, /*#__PURE__*/React.createElement(Select, {
    className: styles.SelectCurrency,
    name: props.name,
    value: currency.code,
    onSelect: function onSelect(value) {
      setCurrency(currencies[value]);
    }
  }, Object.keys(currencies).map(function (code, i) {
    var currency = currencies[code];
    return /*#__PURE__*/React.createElement(Option, {
      key: i,
      value: currency.code // this ugly html allows us to display the currency symbol
      // and in the dropdown you can still see the currency name
      ,
      html: "<p style=\"display:flex;justify-content:space-between;align-items: center;\">\n                <span>".concat(currency.symbol, "</span><span>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</span>\n                <span>").concat(currency.name, "<span></p>")
    });
  })), /*#__PURE__*/React.createElement(Input, {
    required: props.required,
    className: styles.CurrencyInput,
    type: "number",
    value: monetaryValue,
    onChange: function onChange(evt) {
      var value = evt.target.value;

      if (!Number(value)) {
        console.error("FieldTypeCurrency: Invalid value, not a number", value); // TODO broadcast error
      }

      if (props.onChange) {
        props.onChange(value, props.name, props.datatype);
      }

      setMonetaryValue(value);
    }
  })), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});