import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import cx from "classnames";
import { Select, Option } from "../Select";
import { FieldDescription } from "../FieldDescription";
import { FieldLabel } from "../FieldLabel";
import styles from "./FieldTypeDropDown.less";
export var FieldTypeDropDown = /*#__PURE__*/React.memo(function FieldTypeDropDown(props) {
  // console.log("FieldTypeDropDown:render");
  return /*#__PURE__*/React.createElement("div", {
    className: cx(styles.FieldTypeDropDown, props.className)
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement(Select, {
    name: props.name,
    loading: props.loading,
    value: props.value || "0",
    onSelect: function onSelect(value, name) {
      if (props.onChange) {
        props.onChange(value, name, props.datatype);
      }
    }
  }, /*#__PURE__*/React.createElement(Option, {
    value: props.defaultOptValue || "0",
    text: props.defaultOptText || "— None —"
  }), props.children ? props.children : props.options.map(function (opt, i) {
    return /*#__PURE__*/React.createElement(Option, _extends({
      key: i
    }, opt));
  })), props.description && /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});