import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React from "react";
import { Modal, ModalContent, ModalFooter } from "../../../Modal";
import { FieldTypeText } from "../../../FieldTypeText";
import { Button } from "../../../Button";
import { Url } from "../../../Url";
import { schema } from "../react-prosemirror-schema";
import styles from "./EmbedModal.less";
export var EmbedModal = /*#__PURE__*/function (_React$Component) {
  _inherits(EmbedModal, _React$Component);

  var _super = _createSuper(EmbedModal);

  function EmbedModal(props) {
    var _this;

    _classCallCheck(this, EmbedModal);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "embed", /*#__PURE__*/React.createRef());

    _defineProperty(_assertThisInitialized(_this), "state", {
      id: ""
    });

    _defineProperty(_assertThisInitialized(_this), "onEnter", function (evt) {
      if (evt.key === "Enter" || evt.keyCode == 13) {
        _this.onSave();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onSave", function () {
      if (_this.state.id) {
        _this.props.view.dispatch(_this.props.view.state.tr.replaceSelectionWith(schema.nodes.iframe.create({
          id: _this.state.id,
          "data-service": _this.props.options.service
        })));
      }

      zesty.trigger("PROSEMIRROR_DIALOG_CLOSE", "showEmbedModal");

      _this.props.view.focus();
    });

    if (!_this.props.options && !_this.props.options.service) {
      throw new Error("EmbedModal is missing required `options` property with a service specified.");
    }

    return _this;
  }

  _createClass(EmbedModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.embed.current.querySelector("input").focus();
      window.addEventListener("keypress", this.onEnter);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("keypress", this.onEnter);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/React.createElement(Modal, {
        className: styles.EmbedModal,
        open: this.props.open,
        onClose: function onClose() {
          zesty.trigger("PROSEMIRROR_DIALOG_CLOSE", "showEmbedModal");
        }
      }, /*#__PURE__*/React.createElement(ModalContent, null, this.props.options.service === "Twitframe" && /*#__PURE__*/React.createElement("h1", null, /*#__PURE__*/React.createElement("i", {
        className: "fa fa-exclamation-triangle",
        "aria-hidden": "true"
      }), "\xA0", /*#__PURE__*/React.createElement(Url, {
        href: "https://twitframe.com/",
        target: "_blank"
      }, "Twitframe"), " ", "embeds require the full URL for the tweet you would like to embed."), /*#__PURE__*/React.createElement(FieldTypeText, {
        innerRef: this.embed,
        label: "Enter unique ".concat(this.props.options.service, " ID"),
        name: "embed",
        placeholder: "e.g. puXYPrrsrA",
        required: true,
        autoFocus: true,
        onChange: function onChange(id) {
          return _this2.setState({
            id: id
          });
        }
      })), /*#__PURE__*/React.createElement(ModalFooter, null, /*#__PURE__*/React.createElement(Button, {
        type: "save",
        disabled: this.state.id.length === 0,
        onClick: this.onSave
      }, /*#__PURE__*/React.createElement("i", {
        className: "fa fa-plus",
        "aria-hidden": "true"
      }), "Insert Embed")));
    }
  }]);

  return EmbedModal;
}(React.Component);