import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useEffect, useState } from "react";
import styles from "./Html.less";
import { html } from "js-beautify";
import { Controlled as CodeMirror } from "react-codemirror2";

require("codemirror/mode/htmlmixed/htmlmixed");

function parse() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  var formated = html(str, {
    indent_size: 2
  });
  return formated;
}

export function HtmlEditor(props) {
  var _useState = useState(parse(props.value)),
      _useState2 = _slicedToArray(_useState, 2),
      parsed = _useState2[0],
      setParsed = _useState2[1]; // NOTE: Update parsed value when version changes


  useEffect(function () {
    setParsed(parse(props.value));
  }, [props.version]);
  return /*#__PURE__*/React.createElement(CodeMirror, {
    className: styles.Html,
    value: parsed,
    options: {
      autoCursor: false,
      mode: "htmlmixed",
      // theme: "material",
      lineNumbers: true
    },
    onBeforeChange: function onBeforeChange(editor, data, value) {
      setParsed(value.trim());
    },
    onChange: function onChange(editor, data, value) {
      if (props.onChange) {
        props.onChange(value.trim());
      }
    }
  });
}