import React, { useMemo } from "react"; // import { HtmlEditor } from "@aeaton/react-prosemirror";

import { HtmlEditor } from "./react-prosemirror/HtmlEditor";
import { Floater } from "@aeaton/react-prosemirror";
import { MenuBar } from "./react-prosemirror/MenuBar";
import { schema } from "./react-prosemirror-schema";
import { plugins } from "./react-prosemirror-plugins";
import { inline } from "./react-prosemirror-menu";
import { ImageResizeView } from "./prosemirror-views/ImageResizeView";
import { IframeResizeView } from "./prosemirror-views/IframeResizeView";
import { VideoResizeView } from "./prosemirror-views/VideoResizeView";
import styles from "./Inline.less";
export function InlineEditor(props) {
  // NOTE: only recreate options, which cause prosemirror update,
  // when the version changes. Otherwise prosemirror manages
  // it's own internal document model
  var options = useMemo(function () {
    return {
      plugins: plugins,
      schema: schema
    };
  }, [props.version]);
  return /*#__PURE__*/React.createElement(HtmlEditor, {
    options: options,
    value: props.value,
    version: props.version,
    onChange: props.onChange,
    render: function render(_ref) {
      var editor = _ref.editor,
          view = _ref.view;
      return /*#__PURE__*/React.createElement("section", {
        className: styles.InlineEditor
      }, /*#__PURE__*/React.createElement(Floater, {
        view: view
      }, /*#__PURE__*/React.createElement(MenuBar, {
        menu: inline({
          mediaBrowser: props.mediaBrowser
        }),
        view: view
      })), editor);
    },
    nodeViews: {
      image: function image(node, view, getPos) {
        return new ImageResizeView(node, view, getPos);
      },
      iframe: function iframe(node, view, getPos) {
        return new IframeResizeView(node, view, getPos);
      },
      video: function video(node, view, getPos) {
        return new VideoResizeView(node, view, getPos);
      }
    }
  });
}