import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React from "react";
import { toggleMark } from "prosemirror-commands";
import { Modal, ModalContent, ModalFooter } from "../../../Modal";
import { FieldTypeText } from "../../../FieldTypeText";
import { Button } from "../../../Button";
import { Input } from "../../../Input";
import { schema } from "../react-prosemirror-schema";
import styles from "./LinkModal.less";
export var LinkModal = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(LinkModal, _React$PureComponent);

  var _super = _createSuper(LinkModal);

  function LinkModal() {
    var _this;

    _classCallCheck(this, LinkModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "url", /*#__PURE__*/React.createRef());

    _defineProperty(_assertThisInitialized(_this), "state", {
      target: "_blank",
      href: ""
    });

    _defineProperty(_assertThisInitialized(_this), "onEnter", function (evt) {
      if (evt.key === "Enter" || evt.keyCode == 13) {
        _this.onSave();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onSave", function () {
      // Trigger empty setState in order to wait for the state to settle
      // before triggering mark and exit
      _this.setState({}, function () {
        if (_this.state.href) {
          toggleMark(schema.marks.link, _this.state)(_this.props.view.state, _this.props.view.dispatch);
        }

        zesty.trigger("PROSEMIRROR_DIALOG_CLOSE", "showLinkModal");

        _this.props.view.focus();
      });
    });

    return _this;
  }

  _createClass(LinkModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.url.current.querySelector("input").focus();
      window.addEventListener("keypress", this.onEnter);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("keypress", this.onEnter);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/React.createElement(Modal, {
        className: styles.LinkModal,
        open: this.props.open,
        onClose: function onClose() {
          zesty.trigger("PROSEMIRROR_DIALOG_CLOSE", "showLinkModal");
        }
      }, /*#__PURE__*/React.createElement(ModalContent, null, /*#__PURE__*/React.createElement(FieldTypeText, {
        innerRef: this.url,
        label: "What url should this link to?",
        name: "linkUrl",
        placeholder: "https://",
        required: true,
        autoFocus: true,
        onChange: function onChange(href) {
          return _this2.setState({
            href: href
          });
        }
      }), /*#__PURE__*/React.createElement("label", null, "Open link in a new browser window?", " ", /*#__PURE__*/React.createElement(Input, {
        name: "linkTarget",
        type: "checkbox",
        checked: this.state.target === "_blank" ? true : false,
        onChange: function onChange() {
          return _this2.setState({
            target: _this2.state.target === "_blank" ? "_self" : "_blank"
          });
        }
      }))), /*#__PURE__*/React.createElement(ModalFooter, null, /*#__PURE__*/React.createElement(Button, {
        type: "save",
        disabled: this.state.href.length === 0,
        onClick: this.onSave
      }, /*#__PURE__*/React.createElement("i", {
        className: "fa fa-plus",
        "aria-hidden": "true"
      }), "Insert Link")));
    }
  }]);

  return LinkModal;
}(React.PureComponent);