import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useCallback, useEffect, useState } from "react";
import styles from "./Markdown.less";
export function MarkdownEditor(props) {
  // NOTE: controlled component
  var _useState = useState(props.value),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var onInput = useCallback(function (evt) {
    setValue(evt.target.value); // emit change to listeners

    props.onChange(evt.target.value);
  }); // update value if the version changes

  useEffect(function () {
    return setValue(props.value);
  }, [props.version]);
  return /*#__PURE__*/React.createElement("textarea", {
    className: styles.Markdown,
    placeholder: props.placeholder,
    value: value,
    onInput: onInput,
    onSubmit: function onSubmit(evt) {
      return evt.preventDefault();
    }
  });
}