import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
@see https://prosemirror.net/docs/guide/#view.node_views
@see https://glitch.com/edit/#!/toothsome-shoemaker
**/
export var IframeResizeView = /*#__PURE__*/function () {
  function IframeResizeView(node, view, getPos) {
    _classCallCheck(this, IframeResizeView);

    this.node = node;
    this.outerView = view;
    this.getPos = getPos;
    var iframe = document.createElement("iframe"); // Need to send attributes through dom creation process
    // as that is when we determine the embeded service url

    var attrs = node.type.spec.toDOM(node)[1];
    Object.keys(attrs).forEach(function (attr) {
      if (attrs[attr]) {
        iframe.setAttribute(attr, attrs[attr]);
      }
    }); // Lets the image expand when dragging the handle

    iframe.style.width = "100%";
    iframe.style.height = "100%";
    var figure = document.createElement("figure");
    figure.style.position = "relative";
    figure.style.width = attrs.width;
    figure.style.height = attrs.height;
    figure.style.display = "inline-block";
    figure.style.lineHeight = "0"; // necessary so the bottom right arrow is aligned nicely

    figure.appendChild(iframe);
    this.dom = figure;
    this.iframe = iframe;
    this.handle = this.addHandle();
  }

  _createClass(IframeResizeView, [{
    key: "selectNode",
    value: function selectNode() {
      this.iframe.classList.add("ProseMirror-selectednode");
    }
  }, {
    key: "deselectNode",
    value: function deselectNode() {
      this.iframe.classList.remove("ProseMirror-selectednode");
    }
  }, {
    key: "addHandle",
    value: function addHandle() {
      var _this = this;

      var handle = document.createElement("span");
      handle.style.position = "absolute";
      handle.style.bottom = "0px";
      handle.style.right = "0px";
      handle.style.width = "10px";
      handle.style.height = "10px";
      handle.style.border = "3px solid orange";
      handle.style.borderTop = "none";
      handle.style.borderLeft = "none";
      handle.style.cursor = "nwse-resize";

      handle.onmousedown = function (evt) {
        evt.preventDefault();
        var startX = evt.pageX;
        var startY = evt.pageY;
        var startWidth = _this.dom.offsetWidth;
        var startHeight = _this.dom.offsetHeight;

        var onMouseMove = function onMouseMove(evt) {
          var currentX = evt.pageX;
          var currentY = evt.pageY;
          var endWidth = startWidth + (currentX - startX);
          var endHeight = startHeight + (currentY - startY);
          _this.dom.style.width = "".concat(endWidth, "px");
          _this.dom.style.height = "".concat(endHeight, "px");
        };

        var onMouseUp = function onMouseUp(evt) {
          evt.preventDefault();
          document.removeEventListener("mousemove", onMouseMove);
          document.removeEventListener("mouseup", onMouseUp);

          var transaction = _this.outerView.state.tr.setNodeMarkup(_this.getPos(), null, _objectSpread(_objectSpread({}, _this.node.attrs), {}, {
            width: _this.dom.style.width,
            height: _this.dom.style.height
          })).setSelection(_this.outerView.state.selection);

          _this.outerView.dispatch(transaction);
        };

        document.addEventListener("mousemove", onMouseMove);
        document.addEventListener("mouseup", onMouseUp);
      };

      this.dom.appendChild(handle);
      return handle;
    }
  }]);

  return IframeResizeView;
}();