import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
@see https://prosemirror.net/docs/guide/#view.node_views
@see https://glitch.com/edit/#!/toothsome-shoemaker
**/
export var ImageResizeView = /*#__PURE__*/function () {
  function ImageResizeView(node, view, getPos) {
    _classCallCheck(this, ImageResizeView);

    this.node = node;
    this.outerView = view;
    this.getPos = getPos;
    var figure = document.createElement("figure");
    figure.style.position = "relative";
    figure.style.width = node.attrs.width;
    figure.style.height = node.attrs.height;
    figure.style.display = "inline-block";
    figure.style.lineHeight = "0"; // necessary so the bottom right arrow is aligned nicely

    var img = document.createElement("img");
    Object.keys(node.attrs).forEach(function (attr) {
      if (node.attrs[attr]) {
        img.setAttribute(attr, node.attrs[attr]);
      }
    }); // Lets the image expand when dragging the handle

    img.style.width = "100%";
    img.style.height = "100%";
    figure.appendChild(img);
    this.dom = figure;
    this.img = img;
    this.handle = this.addHandle();
  }

  _createClass(ImageResizeView, [{
    key: "selectNode",
    value: function selectNode() {
      this.img.classList.add("ProseMirror-selectednode");
    }
  }, {
    key: "deselectNode",
    value: function deselectNode() {
      this.img.classList.remove("ProseMirror-selectednode");
    }
  }, {
    key: "addHandle",
    value: function addHandle() {
      var _this = this;

      var handle = document.createElement("span");
      handle.style.position = "absolute";
      handle.style.bottom = "0px";
      handle.style.right = "0px";
      handle.style.width = "10px";
      handle.style.height = "10px";
      handle.style.border = "3px solid orange";
      handle.style.borderTop = "none";
      handle.style.borderLeft = "none";
      handle.style.cursor = "nwse-resize";

      handle.onmousedown = function (e) {
        e.preventDefault();
        var startX = e.pageX;
        var startY = e.pageY;
        var startWidth = _this.dom.offsetWidth;
        var startHeight = _this.dom.offsetHeight;

        var onMouseMove = function onMouseMove(e) {
          var currentX = e.pageX;
          var currentY = e.pageY;
          var endWidth = startWidth + (currentX - startX);
          var endHeight = startHeight + (currentY - startY);
          _this.dom.style.width = "".concat(endWidth, "px");
          _this.dom.style.height = "".concat(endHeight, "px");
        };

        var onMouseUp = function onMouseUp(e) {
          e.preventDefault();
          document.removeEventListener("mousemove", onMouseMove);
          document.removeEventListener("mouseup", onMouseUp);
          var url = _this.node.attrs.src; // if (this.node.attrs["data-zuid"]) {
          //   // TODO make API call to cut new image
          //   url = `${CONFIG.service.media_resolver}/resolve/${
          //     this.node.attrs["data-zuid"]
          //   }/getimage/?w=${this.dom.style.width}&h=${this.dom.style.height}`;
          // }

          var transaction = _this.outerView.state.tr.setNodeMarkup(_this.getPos(), null, _objectSpread(_objectSpread({}, _this.node.attrs), {}, {
            src: url,
            width: _this.dom.style.width,
            height: _this.dom.style.height
          })).setSelection(_this.outerView.state.selection);

          _this.outerView.dispatch(transaction);
        };

        document.addEventListener("mousemove", onMouseMove);
        document.addEventListener("mouseup", onMouseUp);
      };

      this.dom.appendChild(handle);
      return handle;
    }
  }]);

  return ImageResizeView;
}();