import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { getElementAttrs, attributes } from "./index.js"; // :: NodeSpec A heading textblock, with a `level` attribute that
// should hold the number 1 to 6. Parsed and serialized as `<h1>` to
// `<h6>` elements.

export var heading = {
  attrs: _objectSpread(_objectSpread({}, attributes()), {}, {
    level: {
      "default": 1
    }
  }),
  content: "inline*",
  group: "block",
  defining: true,
  parseDOM: [{
    tag: "h1",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 1
      });
    }
  }, {
    tag: "h2",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 2
      });
    }
  }, {
    tag: "h3",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 3
      });
    }
  }, {
    tag: "h4",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 4
      });
    }
  }, {
    tag: "h5",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 5
      });
    }
  }, {
    tag: "h6",
    getAttrs: function getAttrs(dom) {
      var attrs = getElementAttrs(dom);
      return _objectSpread(_objectSpread({}, attrs), {}, {
        level: 6
      });
    }
  }],
  toDOM: function toDOM(node) {
    return ["h" + node.attrs.level, _objectSpread(_objectSpread({}, node.attrs), {}, {
      level: null
    }), 0];
  }
};