import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { getElementAttrs, attributes } from "./index.js";
export var iframe = {
  group: "inline",
  // Allow this node to be child of paragraph
  inline: true,
  attrs: _objectSpread(_objectSpread({}, attributes()), {}, {
    height: {
      "default": null
    },
    width: {
      "default": null
    },
    scrolling: {
      "default": null
    },
    frameborder: {
      "default": "0"
    },
    allow: {
      "default": null
    },
    allowfullscreen: {
      "default": null
    },
    name: {
      "default": null
    },
    referrerpolicy: {
      "default": null
    },
    sandbox: {
      "default": null
    },
    src: {
      "default": null
    },
    srcdoc: {
      "default": null
    },
    // Used to track embed service
    "data-service": {
      "default": null
    },
    // Custom service attributes
    "data-instgrm-payload-id": {
      "default": null
    }
  }),
  parseDOM: [{
    tag: "iframe",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    switch (node.attrs["data-service"]) {
      case "Instagram":
        return ["iframe", _objectSpread(_objectSpread({}, node.attrs), {}, {
          src: node.attrs.src || "https://www.instagram.com/p/".concat(node.attrs.id, "/embed/captioned"),
          height: node.attrs.height || "600px",
          width: node.attrs.width || "500px"
        })];
        break;

      case "YouTube":
        return ["iframe", _objectSpread(_objectSpread({}, node.attrs), {}, {
          src: node.attrs.src || "https://www.youtube.com/embed/".concat(node.attrs.id, "?modestbranding=1&rel=0"),
          allow: node.attrs.allow || "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture",
          allowfullscreen: node.attrs.allowfullscreen || true,
          height: node.attrs.height || "315px",
          width: node.attrs.width || "560px"
        })];
        break;

      case "Twitframe":
        return ["iframe", _objectSpread(_objectSpread({}, node.attrs), {}, {
          src: node.attrs.src || "https://twitframe.com/show?url=".concat(encodeURI(node.attrs.id)),
          height: node.attrs.height || "315px",
          width: node.attrs.width || "560px"
        })];
        break;

      default:
        return ["iframe", node.attrs];
    }
  }
};