import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// import { tableNodes } from "prosemirror-tables";
import { getElementAttrs, attributes } from "./index.js";
var attrs = attributes(); // const nodes = tableNodes({
//   tableGroup: "block",
//   cellContent: "block+"
// });
//
// nodes["table"].attrs = { ...attrs, width: { default: null } };
// nodes["table_cell"].attrs = nodes["table_header"].attrs = {
//   ...attrs,
//   colspan: { default: 1 },
//   rowspan: { default: 1 },
//   colwidth: { default: null },
//   headers: { default: null }
// };
//
// console.log("tableNodes", nodes);
//
// export default nodes;

/**
  Override `prosemirror-tables` node definitions to provide custom
  attributes. Requires providing the `tableRole` property for
  the plugins to work.
  @see https://github.com/prosemirror/prosemirror-tables/
**/
// console.log("default attrs", attrs);

export var table = {
  content: "(colgroup | caption | table_body)+",
  // content: "table_row+",
  tableRole: "table",
  isolating: true,
  group: "block",
  attrs: _objectSpread(_objectSpread({}, attrs), {}, {
    width: {
      "default": null
    }
  }),
  parseDOM: [{
    tag: "table",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    // return ["table", ["tbody", 0]];
    return ["table", node.attrs, 0];
  }
};
export var table_body = {
  content: "table_row+",
  tableRole: "table_body",
  // isolating: true,
  group: "block",
  attrs: attrs,
  parseDOM: [{
    tag: "tbody",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["tbody", node.attrs, 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr
 */

export var caption = {
  content: "inline*",
  attrs: attrs,
  parseDOM: [{
    tag: "caption",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["caption", node.attrs, 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr
 */

export var table_row = {
  content: "(table_cell | table_header)*",
  tableRole: "row",
  attrs: attrs,
  parseDOM: [{
    tag: "tr",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["tr", node.attrs, 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td
 */

export var table_cell = {
  content: "block+",
  tableRole: "cell",
  attrs: _objectSpread(_objectSpread({}, attrs), {}, {
    colspan: {
      "default": 1
    },
    rowspan: {
      "default": 1
    },
    // colwidth: { default: null },
    headers: {
      "default": null
    }
  }),
  isolating: true,
  parseDOM: [{
    tag: "td",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["td", node.attrs, 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th
 */

export var table_header = {
  content: "block+",
  tableRole: "header_cell",
  attrs: _objectSpread(_objectSpread({}, attrs), {}, {
    abbr: {
      "default": null
    },
    colspan: {
      "default": 1
    },
    rowspan: {
      "default": 1
    },
    // colwidth: { default: null },
    scope: {
      "default": null
    }
  }),
  isolating: true,
  parseDOM: [{
    tag: "th",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["th", node.attrs, 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup
 */

export var colgroup = {
  content: "col+",
  attrs: _objectSpread(_objectSpread({}, attrs), {}, {
    span: {
      "default": null
    }
  }),
  parseDOM: [{
    tag: "colgroup",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["colgroup", _objectSpread({}, node.attrs), 0];
  }
};
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col
 */

export var col = {
  attrs: _objectSpread(_objectSpread({}, attrs), {}, {
    span: {
      "default": null
    },
    width: {
      "default": null
    }
  }),
  parseDOM: [{
    tag: "col",
    getAttrs: function getAttrs(dom) {
      return getElementAttrs(dom);
    }
  }],
  toDOM: function toDOM(node) {
    return ["col", _objectSpread({}, node.attrs)];
  }
};
export default {
  table: table,
  table_body: table_body,
  table_row: table_row,
  table_cell: table_cell,
  table_header: table_header,
  caption: caption,
  colgroup: colgroup,
  col: col
};