import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React from "react";
import { EditorState } from "prosemirror-state";
import { EditorView } from "prosemirror-view";
import "prosemirror-view/style/prosemirror.css";

var Editor = /*#__PURE__*/function (_React$Component) {
  _inherits(Editor, _React$Component);

  var _super = _createSuper(Editor);

  function Editor(props) {
    var _this;

    _classCallCheck(this, Editor);

    _this = _super.call(this, props);
    _this.editorRef = /*#__PURE__*/React.createRef();
    return _this;
  }

  _createClass(Editor, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this2 = this;

      this.view = new EditorView(null, {
        state: EditorState.create(this.props.options),
        dispatchTransaction: function dispatchTransaction(transaction) {
          var _this2$view$state$app = _this2.view.state.applyTransaction(transaction),
              state = _this2$view$state$app.state,
              transactions = _this2$view$state$app.transactions;

          _this2.view.updateState(state);

          if (transactions.some(function (tr) {
            return tr.docChanged;
          }) && _this2.props.onChange) {
            _this2.props.onChange(state.doc);
          }

          _this2.forceUpdate();
        },
        attributes: this.props.attributes,
        nodeViews: this.props.nodeViews
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.editorRef.current.appendChild(this.view.dom);

      if (this.props.autoFocus) {
        this.view.focus();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.view) {
        this.view.destroy();
        this.view = null;
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      // NOTE: If prosemirror options have changed
      // trigger prosemirrors internal document update
      if (nextProps.options !== this.props.options) {
        this.view.updateState(EditorState.create(nextProps.options));
      } // NOTE: if modals are provided and their display state changes, re-render


      if (nextProps.modals && this.props.modals) {
        if (nextProps.modals.showEmbedModal !== this.props.modals.showEmbedModal || nextProps.modals.showLinkModal !== this.props.modals.showLinkModal) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var editor = /*#__PURE__*/React.createElement("div", {
        ref: this.editorRef
      });
      return this.props.render && this.view ? this.props.render({
        editor: editor,
        view: this.view
      }) : editor;
    }
  }]);

  return Editor;
}(React.Component);

export { Editor as default };