import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import map from "lodash/map";
import classnames from "classnames";
import classes from "./MenuBar.module.less";

var Button = function Button(view) {
  return function (item, key) {
    var _classnames;

    return /*#__PURE__*/React.createElement("button", {
      key: key,
      type: "button",
      className: classnames((_classnames = {}, _defineProperty(_classnames, classes.button, true), _defineProperty(_classnames, classes.active, item.active && item.active(view.state)), _classnames)),
      title: item.title,
      disabled: item.enable && !item.enable(view.state),
      onMouseDown: function onMouseDown(e) {
        e.preventDefault();
        item.run(view.state, view.dispatch, view);
      }
    }, item.content);
  };
};

export var MenuBar = function MenuBar(_ref) {
  var menu = _ref.menu,
      children = _ref.children,
      view = _ref.view;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.bar
  }, children && /*#__PURE__*/React.createElement("span", {
    className: classes.group
  }, children), map(menu, function (item, key) {
    if (key.includes("_dropdown")) {
      var _classnames2;

      return /*#__PURE__*/React.createElement("span", {
        key: key,
        className: classnames(classes.group, classes["dropdown"], classes[item.classname])
      }, /*#__PURE__*/React.createElement("span", {
        className: classnames((_classnames2 = {}, _defineProperty(_classnames2, classes.button, true), _defineProperty(_classnames2, classes.active, item.active && item.active(state)), _defineProperty(_classnames2, classes["dropdown-control"], true), _classnames2)),
        title: item.title
      }, item.content), /*#__PURE__*/React.createElement("div", {
        className: classes["dropdown-menu"]
      }, map(item.children, Button(view))));
    } else {
      return /*#__PURE__*/React.createElement("span", {
        key: key,
        className: classes.group
      }, map(item, Button(view)));
    }
  }));
};