import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from "react";
import cx from "classnames";
import { Select, Option } from "../Select";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import { Converter } from "./Converter";
import styles from "./FieldTypeEditor.less";
export var FieldTypeEditor = /*#__PURE__*/React.memo(function FieldTypeEditor(props) {
  // Handle legacy wysiwyg_advanced field datatype
  var initialEditorType = props.datatype === "wysiwyg_advanced" ? "wysiwyg_basic" : props.datatype; // manage component state as the experience allows switching editor types

  var _useState = useState(initialEditorType),
      _useState2 = _slicedToArray(_useState, 2),
      editor = _useState2[0],
      setEditor = _useState2[1];

  return /*#__PURE__*/React.createElement("div", {
    className: cx(styles.FieldTypeEditor, props.className)
  }, /*#__PURE__*/React.createElement("label", {
    className: styles.FieldTypeEditorLabel
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.FieldTypeEditorLabel__right
  }, /*#__PURE__*/React.createElement(Select, {
    name: "editor",
    className: styles.EditorSelection,
    onSelect: function onSelect(editor) {
      return setEditor(editor);
    },
    value: editor
  }, /*#__PURE__*/React.createElement(Option, {
    value: "wysiwyg_basic",
    text: "WYSIWYG"
  }), /*#__PURE__*/React.createElement(Option, {
    value: "markdown",
    text: "Markdown"
  }), /*#__PURE__*/React.createElement(Option, {
    value: "article_writer",
    text: "Inline"
  }), /*#__PURE__*/React.createElement(Option, {
    value: "html",
    text: "HTML"
  })), props === null || props === void 0 ? void 0 : props.endLabel)), /*#__PURE__*/React.createElement("div", {
    className: styles.FieldTypeEditorPM,
    onFocus: props.onFocus,
    onBlur: props.onBlur
  }, /*#__PURE__*/React.createElement(Converter, {
    editor: editor,
    value: props.value,
    version: props.version,
    name: props.name,
    datatype: props.datatype,
    onChange: props.onChange,
    mediaBrowser: props.mediaBrowser
  })), props.description && /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});