import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React, { Fragment } from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faTimes, faPlus } from "@fortawesome/free-solid-svg-icons";
import { Button } from "../Button";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeImage.less";
export var FieldTypeImage = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(FieldTypeImage, _React$PureComponent);

  var _super = _createSuper(FieldTypeImage);

  function FieldTypeImage() {
    var _this;

    _classCallCheck(this, FieldTypeImage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "addImage", function (images) {
      var imageZUIDs = images.map(function (image) {
        return image.id;
      });

      if (_this.props.onChange) {
        _this.props.onChange([].concat(_toConsumableArray(_this.props.images), _toConsumableArray(imageZUIDs)).join(","), _this.props.name, _this.props.datatype);
      } else {
        throw new Error("missing remove image action");
      }
    });

    _defineProperty(_assertThisInitialized(_this), "removeImage", function (ZUID) {
      if (_this.props.onChange) {
        _this.props.onChange(_this.props.images.filter(function (image) {
          return image !== ZUID;
        }).join(","), _this.props.name, _this.props.datatype);
      } else {
        throw new Error("missing remove image action");
      }
    });

    return _this;
  }

  _createClass(FieldTypeImage, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var maxImages = this.props.limit || 1;
      var imageCount = this.props.images.length;
      return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("label", {
        htmlFor: this.props.name
      }, /*#__PURE__*/React.createElement(FieldLabel, {
        label: this.props.label,
        required: this.props.required,
        tag: this.props.tag,
        maxLength: maxImages,
        valueLength: imageCount,
        tooltip: this.props.tooltip
      })), imageCount > maxImages && /*#__PURE__*/React.createElement("p", {
        className: styles.WarningMsg
      }, "This field is limited to ", maxImages, " ", maxImages > 1 ? "images" : "image"), /*#__PURE__*/React.createElement("div", {
        className: "".concat(styles.FieldTypeImage, " ").concat(imageCount > maxImages ? styles.warn : "")
      }, /*#__PURE__*/React.createElement("div", {
        className: styles.FieldTypeImageContent
      }, this.props.images.map(function (ZUID, i) {
        return /*#__PURE__*/React.createElement(Image, {
          key: i,
          imageZUID: ZUID,
          width: "200",
          height: "200",
          removeImage: _this2.removeImage,
          resolveImage: _this2.props.resolveImage
        });
      }), new Array(Math.max(0, maxImages - imageCount)).fill(0).map(function (el, i) {
        return /*#__PURE__*/React.createElement(ImageSkeleton, _extends({
          key: i
        }, _this2.props, {
          addImage: _this2.addImage
        }));
      }))), /*#__PURE__*/React.createElement(FieldDescription, {
        description: this.props.description
      }));
    }
  }]);

  return FieldTypeImage;
}(React.PureComponent);

_defineProperty(FieldTypeImage, "defaultProps", {
  images: [],
  // Array of image ZUIDs
  limit: 1,
  label: ""
});

function Image(props) {
  return /*#__PURE__*/React.createElement("figure", {
    className: styles.File
  }, props.imageZUID.substr(0, 4) === "http" ? /*#__PURE__*/React.createElement("img", {
    className: styles.image,
    src: props.imageZUID
  }) : /*#__PURE__*/React.createElement("img", {
    className: styles.image,
    src: props.resolveImage(props.imageZUID, props.width, props.height)
  }), /*#__PURE__*/React.createElement(Button, {
    className: styles.remove,
    onClick: function onClick() {
      return props.removeImage(props.imageZUID);
    }
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faTimes,
    className: styles.icon
  })));
}

function ImageSkeleton(props) {
  return /*#__PURE__*/React.createElement("figure", {
    className: cx(styles.File, styles.FileSkeleton)
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      return props.mediaBrowser({
        callback: props.addImage,
        ids: props.value,
        name: props.name,
        displayName: props.label,
        limit: props.limit,
        lock: props.locked
      });
    }
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faPlus,
    className: styles.icon
  })));
}