import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from "react";
import debounce from "lodash/debounce";
import { Select, Option } from "../Select";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
export var FieldTypeInternalLink = /*#__PURE__*/React.memo(function FieldTypeInternalLink(props) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var onSearch = debounce(function (term) {
    if (term && props.onSearch) {
      setLoading(true);
      props.onSearch(term).then(function () {
        setLoading(false);
      });
    }
  }, 250);
  return /*#__PURE__*/React.createElement("article", {
    className: props.className
  }, /*#__PURE__*/React.createElement("label", {
    htmlFor: props.name
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  })), /*#__PURE__*/React.createElement(Select, {
    name: props.name,
    placeholder: props.placeholder,
    value: props.value || "0",
    onSelect: props.onChange,
    onFilter: onSearch // always render search input
    ,
    searchPlaceholder: "Do not see the item you are looking for? Enter a term to search your API.",
    searchLength: "0",
    loading: loading
  }, /*#__PURE__*/React.createElement(Option, {
    value: props.defaultOptValue || "0",
    text: props.defaultOptText || "— None —"
  }), props.options.map(function (option, i) {
    return /*#__PURE__*/React.createElement(Option, _extends({
      key: i
    }, option));
  })), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});