import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from "react";
import cx from "classnames";
import { Input } from "../Input";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeNumber.less";
export var FieldTypeNumber = /*#__PURE__*/React.memo(function FieldTypeNumber(props) {
  if (!Number(props.value) && Number(props.value) !== 0) {
    throw new Error("Provided value is not a number.");
  }

  var _useState = useState(props.value),
      _useState2 = _slicedToArray(_useState, 2),
      number = _useState2[0],
      setNumber = _useState2[1];

  return /*#__PURE__*/React.createElement("label", {
    className: cx(styles.FieldTypeNumber, props.className)
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement(Input, {
    type: "number",
    required: props.required,
    value: number,
    onChange: function onChange(evt) {
      if (props.onChange) {
        props.onChange(evt.target.value, props.name, props.datatype);
      }

      setNumber(evt.target.value);
    }
  }), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});