import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from "react";
import { Loader } from "../Loader";
import { Select, Option } from "../Select";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription"; // import styles from "./FieldTypeOneToOne.less";

export var FieldTypeOneToOne = /*#__PURE__*/React.memo(function FieldTypeOneToOne(props) {
  // console.log("FieldTypeOneToOne:render");
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loaded = _useState2[0],
      setLoaded = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1];

  var onClick = function onClick() {
    if (!loaded && props.onOpen) {
      props.onOpen().then(function () {
        setLoading(false);
      });
      setLoaded(true); // Only load data once

      setLoading(true);
    }
  };

  var onSelect = function onSelect(value, name) {
    if (props.onChange) {
      props.onChange(value, name, props.datatype);
    }
  };

  return /*#__PURE__*/React.createElement("article", {
    className: props.className
  }, /*#__PURE__*/React.createElement("label", {
    htmlFor: props.name
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  })), /*#__PURE__*/React.createElement(Select, {
    name: props.name,
    value: props.value || "0",
    onClick: onClick,
    onSelect: onSelect
  }, /*#__PURE__*/React.createElement(Option, {
    value: props.defaultOptValue || "0",
    text: props.defaultOptText || "— None —"
  }), loading && /*#__PURE__*/React.createElement(Loader, null), props.children ? props.children : props.options.map(function (opt, i) {
    return /*#__PURE__*/React.createElement(Option, _extends({
      key: i
    }, opt));
  })), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});