import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState, useEffect } from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faPlus, faMinus } from "@fortawesome/free-solid-svg-icons";
import { Input } from "../Input";
import { Button } from "../Button";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeSort.less";
export var FieldTypeSort = /*#__PURE__*/React.memo(function FieldTypeSort(props) {
  // console.log("FieldTypeSort:render");
  var _useState = useState(Number(props.value) || 0),
      _useState2 = _slicedToArray(_useState, 2),
      sort = _useState2[0],
      setSort = _useState2[1];

  useEffect(function () {
    setSort(Number(props.value) || 0);
  }, [props.value]);

  var handleClick = function handleClick(evt, increment) {
    evt.stopPropagation();
    var value = increment ? Number(sort) + 1 : Number(sort) - 1;

    if (props.onChange) {
      props.onChange(value, props.name, props.datatype);
    }

    setSort(value);
  };

  var handleChange = function handleChange(evt) {
    evt.stopPropagation();
    var value = Number(evt.target.value);

    if (props.onChange) {
      props.onChange(value, props.name, props.datatype);
    }

    setSort(value);
  };

  return /*#__PURE__*/React.createElement("article", {
    className: cx(styles.FieldTypeSort, props.className)
  }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  })), /*#__PURE__*/React.createElement("section", {
    className: styles.Sort
  }, /*#__PURE__*/React.createElement(Button, {
    className: cx(styles.Increment, styles.Left),
    onClick: function onClick(evt) {
      return handleClick(evt, true);
    }
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faPlus
  })), /*#__PURE__*/React.createElement(Input, {
    className: styles.SortNumber,
    type: "number",
    value: sort,
    onChange: handleChange,
    required: props.required
  }), /*#__PURE__*/React.createElement(Button, {
    className: cx(styles.Increment, styles.Right),
    onClick: function onClick(evt) {
      return handleClick(evt);
    }
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faMinus
  }))), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});