import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import cx from "classnames";
import { Input } from "../Input";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeText.less";
export var FieldTypeText = /*#__PURE__*/React.memo(function FieldTypeText(props) {
  // console.log("FieldTypeText:render");
  if (!props.name) {
    throw new Error('Missing required attribute "name". See https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes');
  }

  var maxLength = props.maxLength ? props.maxLength : 150;
  var valueLength = props.value && props.value.length ? props.value.length : 0;
  return /*#__PURE__*/React.createElement("label", {
    ref: props.innerRef,
    className: cx(styles.FieldTypeText, props.className, valueLength > maxLength ? styles.Error : "")
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    maxLength: maxLength,
    valueLength: valueLength,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement(Input, _extends({}, props, {
    type: props.type || "text",
    name: props.name,
    value: props.value,
    placeholder: props.placeholder,
    required: props.required,
    autoFocus: props.autofocus,
    onChange: function onChange(evt) {
      if (props.onChange) {
        props.onChange(evt.target.value, evt.target.name, props.datatype);
      }
    },
    disabled: props.disabled,
    error: props.error
  })), valueLength > maxLength && /*#__PURE__*/React.createElement("span", {
    className: styles.ErrorDescription
  }, "Your input is over the specified limit"), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});