import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import cx from "classnames";
import { Textarea } from "../Textarea";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
/**
 * Controlled component
 */

import styles from "./FieldTypeTextarea.less";
export var FieldTypeTextarea = /*#__PURE__*/React.memo(function FieldTypeTextarea(props) {
  // console.log("FieldTypeTextarea:render");
  if (!props.name) {
    throw new Error('Missing required attribute "name". See https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes');
  }

  return /*#__PURE__*/React.createElement("label", {
    className: cx(styles.FieldTypeTextarea, props.className, (props.value && props.value.length) > (props.maxLength || 150) ? styles.Error : "")
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    maxLength: props.maxLength || 150,
    valueLength: props.value && props.value.length || "0",
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement(Textarea, _extends({}, props, {
    type: "textarea",
    onChange: function onChange(evt) {
      if (props.onChange) {
        props.onChange(evt.target.value, props.name, props.datatype);
      }
    }
  })), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});