import React, { useEffect } from "react";
import cx from "classnames";
import { v4 as uuidv4 } from "uuid";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faClipboard } from "@fortawesome/free-solid-svg-icons";
import { Input } from "../Input";
import { FieldDescription } from "../FieldDescription";
import { FieldLabel } from "../FieldLabel";
import styles from "./FieldTypeUUID.less";
export var FieldTypeUUID = /*#__PURE__*/React.memo(function FieldTypeUUID(props) {
  // console.log("FieldTypeUUID:render");
  useEffect(function () {
    // NOTE may want to add a check to ensure the itemZUID is 'new'
    if (props.name && !props.value) {
      // there is no UUID and it needs to be generated
      props.onChange(uuidv4(), props.name, props.datatype);
    }
  }, []);
  return /*#__PURE__*/React.createElement("label", {
    className: cx(styles.FieldTypeUUID, props.className)
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.DateFieldTypeInput
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    className: styles.Icon,
    icon: faClipboard,
    "aria-hidden": "true",
    title: "Click to Copy",
    onClick: function onClick(e) {
      var input = document.createElement("input");
      document.body.appendChild(input);
      input.value = props.value;
      input.focus();
      input.select();
      var result = document.execCommand("copy");
      input.remove();

      if (result === "unsuccessful") {
        return props.dispatch(notify({
          type: "error",
          message: "Failed to copy the team ID to your clipboard"
        }));
      }
    }
  }), /*#__PURE__*/React.createElement(Input, {
    type: "text",
    readOnly: true,
    required: props.required,
    defaultValue: props.value || ""
  })), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});