import React from "react";
import cx from "classnames";
import { Input } from "../Input";
import { FieldLabel } from "../FieldLabel";
import { FieldDescription } from "../FieldDescription";
import styles from "./FieldTypeUrl.less";
export var FieldTypeUrl = /*#__PURE__*/React.memo(function FieldTypeUrl(props) {
  // console.log("FieldTypeUrl:render");
  return /*#__PURE__*/React.createElement("article", {
    className: cx(styles.FieldTypeUrl, props.className, props.maxLength && props.value.length > props.maxLength ? styles.Error : null)
  }, /*#__PURE__*/React.createElement(FieldLabel, {
    label: props.label,
    required: props.required,
    tag: props.tag,
    maxLength: props.maxLength,
    valueLength: props.value && props.value.length || "0",
    tooltip: props.tooltip
  }), /*#__PURE__*/React.createElement(Input, {
    type: "url",
    required: props.required,
    onChange: function onChange(evt) {
      if (props.onChange) {
        props.onChange(evt.target.value, props.name, props.datatype);
      }
    },
    value: props.value
  }), /*#__PURE__*/React.createElement(FieldDescription, {
    description: props.description
  }));
});