import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import React from "react";
import cx from "classnames";
import styles from "./InputPassword.less";
import { Input } from "../Input";

var charMeter = _toConsumableArray(Array(16).keys());

export function InputPassword(props) {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Input, _extends({}, props, {
    type: "password",
    pattern: "^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)[?=.*[a-zA-Z0-9!@#$%^&()<>.,:;[\\]{}\\-_.+,/]{8,}$",
    className: props.className,
    onChange: props.onChange ? props.onChange : function () {},
    value: props.value === null ? "" : props.value
  })), /*#__PURE__*/React.createElement("div", null, charMeter.map(function (_char) {
    return /*#__PURE__*/React.createElement("span", {
      key: "charMeter" + _char,
      className: cx(styles.charMeter, _defineProperty({}, styles.charInput, _char < props.value.length))
    });
  })), /*#__PURE__*/React.createElement("div", {
    className: styles.passwordCriteriaMessage
  }, "Minimum", " ", /*#__PURE__*/React.createElement("span", {
    className: cx(styles.passwordCriteria, _defineProperty({}, styles.passwordMatches, props.value.length >= 8))
  }, "8"), " ", "Characters. One", " ", /*#__PURE__*/React.createElement("span", {
    className: cx(styles.passwordCriteria, _defineProperty({}, styles.passwordMatches, /[a-z]/.test(props.value)))
  }, "Lowercase"), ",", " ", /*#__PURE__*/React.createElement("span", {
    className: cx(styles.passwordCriteria, _defineProperty({}, styles.passwordMatches, /[A-Z]/.test(props.value)))
  }, "Uppercase"), ", and", " ", /*#__PURE__*/React.createElement("span", {
    className: cx(styles.passwordCriteria, _defineProperty({}, styles.passwordMatches, /[0-9]/.test(props.value)))
  }, "Number"), " ", "required."));
}