import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["showIcon", "available"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from "react";
import { Link } from "react-router-dom";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faCaretLeft, faCaretDown } from "@fortawesome/free-solid-svg-icons";
import styles from "./Node.less";
export function Node(props) {
  var _props$icon;

  return /*#__PURE__*/React.createElement("li", {
    className: cx(styles.item, props.lightMode == 'true' ? null : styles.Dark, styles["depth".concat(props.depth)], props.selected.includes(props.path) ? styles.selected : null)
  }, props.type === "directory" ? /*#__PURE__*/React.createElement("span", {
    className: styles.directory
  }, props.icon && /*#__PURE__*/React.createElement("i", {
    className: props.icon
  }), /*#__PURE__*/React.createElement("span", null, props.label)) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Link, {
    to: props.path
  }, props.icon ? (_props$icon = props.icon) !== null && _props$icon !== void 0 && _props$icon.iconName ? /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: props.icon
  }) : props.icon : null, /*#__PURE__*/React.createElement("span", null, props.label)), /*#__PURE__*/React.createElement("span", {
    className: styles.actions
  }, React.Children.map(props.actions, function (action, index) {
    // Run consumer provided function to determine
    // whether action is available
    var isAvailable = action.props.available ? action.props.available(props) : true; // Filter out props which will not translate to the DOM

    var _action$props = action.props,
        showIcon = _action$props.showIcon,
        available = _action$props.available,
        filteredProps = _objectWithoutProperties(_action$props, _excluded);

    var child = _objectSpread(_objectSpread({}, action), {}, {
      props: filteredProps
    });

    return isAvailable && /*#__PURE__*/React.cloneElement(child, {
      key: index,
      className: cx(styles.action, action.props.showIcon ? null : styles.hide, action.props.className),
      onClick: function onClick() {
        return action.props.onClick(props);
      }
    });
  }))), props.collapseNode && Array.isArray(props.children) && Boolean(props.children.length) && /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: props.closed ? faCaretLeft : faCaretDown,
    className: styles.collapse,
    onClick: function onClick() {
      return props.collapseNode(props);
    }
  }));
}