import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import { Node } from "../Node";
import cx from "classnames";
import styles from "./Parent.less";
export function Parent(props) {
  // track recursion depth and pass it as a prop to the node component
  var depth = props.depth + 1 || 1;
  return /*#__PURE__*/React.createElement("article", {
    className: props.lightMode == 'true' ? styles.Parent : cx(styles.Parent, styles.Dark)
  }, /*#__PURE__*/React.createElement("ul", {
    className: props.isClosed ? styles.closed : ""
  }, Array.isArray(props.children) && props.children.length ?
  /*#__PURE__*/
  // if the item has children
  // render the item and then it's children
  React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Node, _extends({}, props, {
    lightMode: props.lightMode,
    depth: depth,
    selected: props.selected,
    collapseNode: props.collapseNode,
    actions: props.actions
  })), props.children.map(function (child) {
    return /*#__PURE__*/React.createElement(Parent, _extends({}, child, {
      // If the current node is closed then
      // tell child nodes to not display
      isClosed: props.closed,
      lightMode: props.lightMode,
      key: child.path,
      depth: depth,
      selected: props.selected,
      collapseNode: props.collapseNode,
      actions: props.actions
    }));
  })) : /*#__PURE__*/React.createElement(Node, _extends({}, props, {
    lightMode: props.lightMode,
    depth: depth,
    selected: props.selected,
    collapseNode: props.collapseNode,
    actions: props.actions
  }))));
}