import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React, { Component, Fragment } from "react";
import debounce from "lodash.debounce";
import cx from "classnames";
import { Select, Option } from "../Select";
import { Search } from "../Search";
import { Loader } from "../Loader";
import styles from "./SearchableList.less";
export var SearchableList = /*#__PURE__*/function (_Component) {
  _inherits(SearchableList, _Component);

  var _super = _createSuper(SearchableList);

  function SearchableList(props) {
    var _this;

    _classCallCheck(this, SearchableList);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "onChange", debounce(function (term) {
      if (!_this.props.onSearch) {
        throw Error("SearchableList component missing onChange property");
      }

      if (term) {
        // Examine Select component state and open dropdown while searching
        // Uses internal Select ref to the selector dom element
        if (!_this.selectList.current.state.dropdownOpen) {
          _this.selectList.current.selector.click();
        }

        _this.setState({
          loading: true
        });

        _this.props.onSearch(term).then(function (res) {
          _this.setState({
            loading: false
          });
        })["catch"](function (err) {
          _this.setState({
            loading: false
          });
        });
      }
    }, 500));

    _this.selectList = /*#__PURE__*/React.createRef();
    _this.state = {
      loading: false
    };
    return _this;
  }

  _createClass(SearchableList, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("div", {
        className: styles.SearchableList
      }, /*#__PURE__*/React.createElement(Search, {
        className: styles.Search,
        placeholder: "Search for items",
        onChange: this.onChange
      }), /*#__PURE__*/React.createElement(Select, {
        ref: this.selectList,
        className: styles.Select,
        name: this.props.name,
        value: this.props.value,
        onSelect: this.props.onSelect
      }, this.state.loading && /*#__PURE__*/React.createElement(Loader, null), this.props.children));
    }
  }]);

  return SearchableList;
}(Component);