import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import React, { Component } from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faCaretDown, faCaretLeft } from "@fortawesome/free-solid-svg-icons";
import { Button } from "../Button";
import { Search } from "../Search";
import { Loader } from "../Loader";
import styles from "./Select.less";
export var Select = /*#__PURE__*/function (_Component) {
  _inherits(Select, _Component);

  var _super = _createSuper(Select);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "handleFilterKeyUp", function (term, name, datatype) {
      if (_this.props.onFilter) {
        _this.props.onFilter(term, name, datatype);
      }

      _this.setState({
        filter: term.trim().toLowerCase()
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onEsc", function (evt) {
      if (evt.key === "Escape" || evt.keyCode == 27) {
        if (_this.state.dropdownOpen) {
          _this.setState({
            dropdownOpen: false
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClose", function (evt) {
      var parent = evt.target.closest(".Select"); // Close this select if the click occured
      // outside a ZestySelect or this instance

      if (!parent || parent !== _this.selector) {
        _this.setState({
          dropdownOpen: false
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "toggleDropdown", function (evt) {
      evt.preventDefault();

      if (evt.target.type === "search") {
        return false;
      }

      if (_this.props.onClick) {
        _this.props.onClick(evt);
      }

      var body = document.querySelector("body");
      var content = document.querySelector("body");

      if (body && content) {
        var contentHeight = content.scrollHeight;

        var selectorPosition = _this.selector.getBoundingClientRect();

        var filter = _this.selector.querySelector(".Filter");

        var selections = _this.selector.querySelector(".selections");

        var initialSelectionsHeight = selections.offsetHeight;
        var scrollOffset = body.scrollTop;

        if (initialSelectionsHeight < contentHeight) {
          if (initialSelectionsHeight + selectorPosition.y > contentHeight) {
            // If we can adjust the dropdown height to fit in the
            // available content space, subtracting the footer 50px height
            var newHeight = Math.floor(contentHeight - selectorPosition.y) - 50;

            if (newHeight > 200 && newHeight < 600) {
              // The options list controls the overflow scrolling
              // so we have to adjust it's height
              selections.querySelector(".options").style.height = newHeight + "px";
            } else {
              selections.style.top = "-" + initialSelectionsHeight + "px";
            }
          }
        }

        if (filter) {
          filter.querySelector("input").focus();
        }
      }

      var nextDropdownState = !_this.state.dropdownOpen; // PERF: Only attach global click listener when this select instance dropdown is open.

      if (nextDropdownState) {
        window.addEventListener("click", _this.onClose);
      } else {
        window.removeEventListener("click", _this.onClose);
      }

      _this.setState({
        dropdownOpen: nextDropdownState
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setSelection", function (evt) {
      var value = evt.currentTarget.dataset.value;

      if (_this.props.onSelect) {
        _this.props.onSelect(value, _this.props.name);
      }

      _this.setState({
        value: value
      });
    });

    if (!props.name) {
      throw new Error("Select components require a `name` property");
    }

    _this.state = {
      dropdownOpen: false,
      value: props.value,
      filter: "",
      searchLength: _this.props.searchLength
    };
    return _this;
  }

  _createClass(Select, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.value !== prevProps.value) {
        this.setState({
          value: this.props.value
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener("keyup", this.onEsc);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("keyup", this.onEsc);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var childrenArr = React.Children.toArray(this.props.children); // console.log('testing childrenArr', childrenArr);

      var childrenFiltered = childrenArr.filter(function (child) {
        if (_this2.state.filter) {
          var _String, _String$toLowerCase, _child$props, _String2, _String2$toLowerCase, _child$props2, _String3, _String3$toLowerCase, _child$props3;

          return ((_String = String((_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.filterValue)) === null || _String === void 0 ? void 0 : (_String$toLowerCase = _String.toLowerCase()) === null || _String$toLowerCase === void 0 ? void 0 : _String$toLowerCase.indexOf(_this2.state.filter)) !== -1 || ((_String2 = String((_child$props2 = child.props) === null || _child$props2 === void 0 ? void 0 : _child$props2.html)) === null || _String2 === void 0 ? void 0 : (_String2$toLowerCase = _String2.toLowerCase()) === null || _String2$toLowerCase === void 0 ? void 0 : _String2$toLowerCase.indexOf(_this2.state.filter)) !== -1 || ((_String3 = String((_child$props3 = child.props) === null || _child$props3 === void 0 ? void 0 : _child$props3.text)) === null || _String3 === void 0 ? void 0 : (_String3$toLowerCase = _String3.toLowerCase()) === null || _String3$toLowerCase === void 0 ? void 0 : _String3$toLowerCase.indexOf(_this2.state.filter)) !== -1;
        } else {
          return true;
        }
      }).map(function (child) {
        return /*#__PURE__*/React.cloneElement(child, {
          onClick: function onClick(evt) {
            // Individual option event listener
            if (child.props.onClick) {
              child.props.onClick(evt);
            }

            _this2.setSelection(evt);
          }
        });
      }); // On each render determine the currently selected option

      var selection = childrenArr.find(function (child) {
        return child.props && child.props.value == _this2.state.value;
      });
      return /*#__PURE__*/React.createElement("div", {
        className: cx("Select", styles.selector, this.state.dropdownOpen ? styles.show : styles.hidden, this.props.className, this.props.error && styles.error),
        onClick: this.toggleDropdown,
        ref: function ref(div) {
          return _this2.selector = div;
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: styles.selection
      }, selection && selection.props.html && /*#__PURE__*/React.createElement("span", {
        className: styles.content,
        dangerouslySetInnerHTML: {
          __html: selection && selection.props.html
        }
      }), selection && selection.props.text && /*#__PURE__*/React.createElement("span", {
        className: styles.content
      }, selection.props.text), selection && selection.props.component && /*#__PURE__*/React.createElement("span", {
        className: styles.content
      }, selection.props.component), /*#__PURE__*/React.createElement(Button, {
        className: styles.chevron
      }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
        className: styles.chevronIcon,
        icon: this.state.dropdownOpen ? faCaretLeft : faCaretDown
      }))), /*#__PURE__*/React.createElement("ul", {
        className: cx("selections", styles.selections)
      }, childrenArr.length > this.props.searchLength && /*#__PURE__*/React.createElement(Search, {
        className: styles.Filter,
        onChange: this.handleFilterKeyUp,
        placeholder: this.props.searchPlaceholder || "Enter a term to filter this list"
      }), this.props.loading && /*#__PURE__*/React.createElement("span", {
        className: styles.Loader
      }, /*#__PURE__*/React.createElement(Loader, null), "\xA0Searching for matching items"), /*#__PURE__*/React.createElement("div", {
        className: cx("options", styles.options)
      }, this.state.dropdownOpen ? childrenFiltered.length ? childrenFiltered : !this.props.loading && /*#__PURE__*/React.createElement(Option, {
        value: "0",
        text: "No options found"
      }) : null)));
    }
  }]);

  return Select;
}(Component);

_defineProperty(Select, "defaultProps", {
  options: [{
    text: "This field is misconfigured",
    value: null
  }],
  searchLength: 50
});

export function Option(_ref) {
  var value = _ref.value,
      html = _ref.html,
      text = _ref.text,
      component = _ref.component,
      onClick = _ref.onClick,
      className = _ref.className;

  if (html) {
    return /*#__PURE__*/React.createElement("li", {
      className: className,
      "data-value": value,
      onClick: onClick,
      dangerouslySetInnerHTML: {
        __html: html
      }
    });
  } else {
    return /*#__PURE__*/React.createElement("li", {
      className: className,
      "data-value": value,
      onClick: onClick
    }, text, component);
  }
}