import React from "react";
import cx from "classnames";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faTimesCircle } from "@fortawesome/free-solid-svg-icons";
import styles from "./Tag.less";
export function Tag(props) {
  return /*#__PURE__*/React.createElement("span", {
    className: cx(styles.Tag, props.error && styles.Error)
  }, /*#__PURE__*/React.createElement("span", {
    className: styles.Content
  }, props.children), /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    icon: faTimesCircle,
    className: styles.Remove,
    onClick: function onClick(evt) {
      evt.stopPropagation();
      evt.preventDefault();

      if (props.onRemove) {
        return props.onRemove(props.value, props.name);
      }
    }
  }));
}